/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.xml;

import com.jiuqi.xml.XMLException;
import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Stack;

public class XMLWriter {
    private String version = "1.0";
    private String encoding = "GBK";
    private String dateFormat = "yyyy-MM-dd";
    private String blank = "";
    private boolean format = true;
    private boolean flag = false;
    private boolean sign = false;
    private boolean beginLock = false;
    private boolean attributeLock = true;
    private boolean valueLock = true;
    private OutputStream out = null;
    private Stack tags = new Stack();
    private int bufferSize = 4096;
    private StringBuffer stringBuffer = new StringBuffer();

    public XMLWriter(OutputStream out) throws XMLException {
        this.out = out;
        this.init();
    }

    public XMLWriter(OutputStream out, String encoding) throws XMLException {
        this.out = out;
        this.encoding = encoding;
        this.init();
    }

    public XMLWriter(OutputStream out, String encoding, String version) throws XMLException {
        this.out = out;
        this.encoding = encoding;
        this.version = version;
        this.init();
    }

    private void init() throws XMLException {
        this.write("<?xml version=\"");
        this.write(this.version);
        this.write("\" encoding=\"");
        this.write(this.encoding);
        this.write("\"?");
    }

    public void beginNode(String name) throws XMLException {
        if (this.beginLock) {
            throw new XMLException("开始节点<" + name + ">置于非法位置");
        }
        if (this.format) {
            this.write(">\n");
            this.write(this.blank);
            this.write("<");
            this.write(name);
            this.blank = String.valueOf(this.blank) + "  ";
        } else {
            this.write("><");
            this.write(name);
        }
        this.valueLock = false;
        this.attributeLock = false;
        this.flag = true;
        this.sign = false;
        this.tags.push(name);
    }

    public void setAttribute(String name) throws XMLException {
        this.setAttribute(name, "");
    }

    public void setAttribute(String name, int value) throws XMLException {
        this.setAttribute(name, String.valueOf(value));
    }

    public void setAttribute(String name, byte value) throws XMLException {
        this.setAttribute(name, String.valueOf(value));
    }

    public void setAttribute(String name, short value) throws XMLException {
        this.setAttribute(name, String.valueOf(value));
    }

    public void setAttribute(String name, long value) throws XMLException {
        this.setAttribute(name, String.valueOf(value));
    }

    public void setAttribute(String name, float value) throws XMLException {
        this.setAttribute(name, String.valueOf(value));
    }

    public void setAttribute(String name, double value) throws XMLException {
        this.setAttribute(name, String.valueOf(value));
    }

    public void setAttribute(String name, char value) throws XMLException {
        this.setAttribute(name, String.valueOf(value));
    }

    public void setAttribute(String name, boolean value) throws XMLException {
        this.setAttribute(name, String.valueOf(value));
    }

    public void setAttribute(String name, Date value) throws XMLException {
        SimpleDateFormat df = new SimpleDateFormat(this.dateFormat);
        this.setAttribute(name, df.format(value));
    }

    public void setAttribute(String name, Object value) throws XMLException {
        this.setAttribute(name, value.toString());
    }

    public void setAttribute(String name, String value) throws XMLException {
        if (this.attributeLock) {
            throw new XMLException("节点属性 " + name + "=\"" + value + "\" 置于非法位置");
        }
        this.write(" ");
        this.write(name);
        this.write("=\"");
        this.writeXml(value);
        this.write("\"");
        this.beginLock = false;
        this.valueLock = false;
    }

    public void setValue() throws XMLException {
        this.setValue("");
    }

    public void setValue(int value) throws XMLException {
        this.setValue(String.valueOf(value));
    }

    public void setValue(byte value) throws XMLException {
        this.setValue(String.valueOf(value));
    }

    public void setValue(short value) throws XMLException {
        this.setValue(String.valueOf(value));
    }

    public void setValue(long value) throws XMLException {
        this.setValue(String.valueOf(value));
    }

    public void setValue(float value) throws XMLException {
        this.setValue(String.valueOf(value));
    }

    public void setValue(double value) throws XMLException {
        this.setValue(String.valueOf(value));
    }

    public void setValue(char value) throws XMLException {
        this.setValue(String.valueOf(value));
    }

    public void setValue(boolean value) throws XMLException {
        this.setValue(String.valueOf(value));
    }

    public void setValue(Date value) throws XMLException {
        SimpleDateFormat df = new SimpleDateFormat(this.dateFormat);
        this.setValue(df.format(value));
    }

    public void setValue(Object value) throws XMLException {
        this.setValue(value.toString());
    }

    public void setValue(String value) throws XMLException {
        if (this.valueLock) {
            throw new XMLException("节点内容 " + value + " 置于非法位置");
        }
        this.write(">");
        this.writeXml(value);
        this.beginLock = true;
        this.valueLock = true;
        this.attributeLock = true;
        this.sign = true;
    }

    public void setContent(String content) throws XMLException {
        if (this.valueLock) {
            throw new XMLException("节点内容 " + content + " 置于非法位置");
        }
        this.write(">");
        this.write("<![CDATA[");
        this.write(content);
        this.write("]]>");
        this.beginLock = true;
        this.valueLock = true;
        this.attributeLock = true;
        this.sign = true;
    }

    public void writeContentNode(String name, String content) throws XMLException {
        this.beginNode(name);
        this.setContent(content);
        this.endNode();
    }

    public void endNode() throws XMLException {
        if (this.tags.isEmpty()) {
            throw new XMLException("此结束节点位置不合法，其对应匹配的开始结点未创建");
        }
        if (this.format) {
            this.blank = this.blank.substring(0, this.blank.length() - 2);
        }
        String name = (String)this.tags.pop();
        if (this.flag) {
            if (this.sign) {
                this.write("</");
                this.write(name);
            } else {
                this.write("/");
            }
        } else {
            this.write(">\n");
            this.write(this.blank);
            this.write("</");
            this.write(name);
        }
        if (this.tags.empty()) {
            this.writeEnd(">");
        }
        this.flag = false;
        this.valueLock = true;
        this.beginLock = false;
        this.attributeLock = true;
    }

    public void writeNode(String name) throws XMLException {
        this.beginNode(name);
        this.endNode();
    }

    public void writeNode(String name, String value) throws XMLException {
        this.beginNode(name);
        this.setValue(value);
        this.endNode();
    }

    private void write(String str) throws XMLException {
        if (str == null) {
            throw new XMLException("不允许在XML中写入NULL值");
        }
        this.stringBuffer.append(str);
        if (this.stringBuffer.length() > this.bufferSize) {
            this.flush();
        }
    }

    private void writeXml(String str) throws XMLException {
        if (str == null) {
            throw new XMLException("不允许在XML中写入NULL值");
        }
        int i = 0;
        while (i < str.length()) {
            if (str.charAt(i) == '\"') {
                this.write("&quot;");
            } else if (str.charAt(i) == '\'') {
                this.write("&apos;");
            } else if (str.charAt(i) == '&') {
                this.write("&amp;");
            } else if (str.charAt(i) == '<') {
                this.write("&lt;");
            } else if (str.charAt(i) == '>') {
                this.write("&gt;");
            } else {
                this.write(str.substring(i, i + 1));
            }
            ++i;
        }
    }

    private void writeEnd(String str) throws XMLException {
        this.stringBuffer.append(str);
        this.flush();
    }

    public void flush() throws XMLException {
        try {
            this.out.write(this.stringBuffer.toString().getBytes(this.encoding));
            this.stringBuffer.delete(0, this.stringBuffer.length());
        }
        catch (IOException e) {
            throw new XMLException(e);
        }
    }

    public boolean isFormat() {
        return this.format;
    }

    public void setFormat(boolean format) {
        this.format = format;
    }

    public String getDateFormat() {
        return this.dateFormat;
    }

    public void setDateFormat(String dateFormat) {
        this.dateFormat = dateFormat;
    }

    public int getBufferSize() {
        return this.bufferSize;
    }

    public void setBufferSize(int bufferSize) {
        this.bufferSize = bufferSize;
    }
}

